/**
 * 公共函数
 */

//全局的配置文件 
var config = {
//	fileTypes : "txt|epub|ebk2|ebk3|pdf|chm|umd|doc|docx|wps|xls|xlsx|et|ppt|pptx|dps|mobi", //允许上传的文件格式 "txt|epub"
    fileTypes : "txt|epub",
	url : "http://"+location.host+"?action=addBook",//"http://localhost/t/post.php",//
	fileLimitSize : 500 * 1024 *1024

}

var file = {
	"inQueue" : [], //已经在队列里面的文件，包括 HTML5上传和 Flash上传的
	"clientHaveFiles" : [] // 客户端已经存在的文件列表
}

/**
 * HTML5 和 flash 公用，所有文件对象集合
 * @var array 
 */
var filesUpload	= []; //

$.ajax({
	url : "http://"+location.host+'?action=getBooksList&t='+(+new Date()),//"http://localhost/t/t.php",//
	async:false,//同步获取数据
	dataType : "json",
	success:function(data){
		
		try{
			var dataLen = data.length;
			if(dataLen > 0 ){
				for(var i=0; i < dataLen;  i++){
					 filesUpload.push(data[i]);
				}
			}
		}catch(e){}
		
	}
})

//统计文件大小
function countFileSize(fileSize)
{
	var KB  = 1024;
	var MB = 1024 * 1024;
	if(KB >= fileSize){
	   return fileSize+"B";
	}else if(MB >= fileSize){
		return (fileSize/KB).toFixed(2)+"KB";
	}else{
		return (fileSize/MB).toFixed(2)+"MB";
	}
}

//如果文件太长进行截取
function substr_string(name)
{
	var maxLen = 15;
	var len = name.length;
	if(len < 17 )return name;
	
	var lastIndex = name.lastIndexOf(".");
	var suffix    = name.substr(lastIndex);
	var pre       = name.substr(0,lastIndex);
	var preLen    = pre.length;
	var preStart  = preLen - 10;
	//前面10个 + 后面5个
	var fileName  =  pre.substr(0,10) + "...." + pre.substr( preStart > 4 ? -4 : -preStart , 4)+suffix;
	return fileName
}


function checkFile(file) {
	
	if(file.size > config.fileLimitSize){
		return "文件太大，不能超过500MB";
	}
	
	if (!file.name || !file.name.toLowerCase().match('('+config.fileTypes+')$')) {
		return "文件格式不对";
	}
	
	var len = filesUpload.length;
	for(var i=0; i< len; i++){
		if(filesUpload[i].name == file.name)	{
			return "文件已经存在";
		}
	}
	return null;
}






/**
 * 添加文件时，回调的函数
 * @param object file 文件对象
 * @param int type 0 是swf 上传的，1 是html5上传的
 */
function fileQueued(file, type)
{
	var size=0 ,fid=file.id, name="";
	type = type || 0;
	
	if(file != undefined )
	{
		//计算文件大小 单位MB
		size = countFileSize(file.size);
		name = substr_string(file.name)
		//创建要插入的元素
//		"<tr id='tr_'"+fid+"><td><div class='bh-poStion'><h1>"+name+"</h1>"+
//						"<div class='bh-tip bh-tip3' id='progress_bar_"+fid+"'>"+
//						"<span id='progress_bar_span_"+fid+"'></span></div>"+
//						"</div></td><td><span class='bh-M'>"+size+"</span></td><td><div class='bh-link' id='handle_button_"+fid+"'>"+
//						"<a href='javascript:void(0)' onclick=userCancelUpload('"+fid+"',"+type+")>取消</a></div></td></tr>";
					
          var HTML = '<li  id="tr_"'+fid+'>'+
					'<dl class="grybg">'+
						'<dt>'+name+'</dt>'+
						'<dd>'+size+'</dd>'+
						'<dd id="handle_button_'+fid+'"  onclick=userCancelUpload("'+fid+'",'+type+') class="orange">'+
							'<span id="progress_bar_span_'+fid+'">0%</span> 取消</dd>'+
					'</dl>'+
					'<div class="jdt"><p  id="progress_bar_p_'+fid+'" ></p></div>'+
			'</li>';
						
						
		jQuery("#tableStyle").append(HTML);
		//保存falsh_id，为上传做准备
		//global_flash_id.push(file.id);
		//更改背景颜色
		changeTrBackGroundColor()
	}
}

function changeTrBackGroundColor()
{
	var getTr=document.getElementById("tableStyle").getElementsByTagName("dl");
	trNum=getTr.length;
	for(var i=0;i<trNum;i++){
		if(i%2==0){
			getTr[i].style.backgroundColor="#f3f3f3";
		}
	}
}	



//上传时返回的状态
function uploadProgress(file, bytesLoaded, bytesTotal) 
{
	if(!$("#progress_bar_p_"+file.id).hasClass("orange")){
		$("#progress_bar_p_"+file.id).addClass("orange");
	}
	$("#progress_bar_p_"+file.id).css("width",(bytesLoaded/bytesTotal)*100+"%");
	$("#progress_bar_span_"+file.id).html(parseInt((bytesLoaded/bytesTotal)*100)+"%");
	
}


//上传成功
function uploadSuccess(file, serverData, res)
{
	var id = "handle_button_"+file.id;
	$("#"+id).replaceWith("<dd>完成</dd>")
}


//取消上传
function userCancelUpload(file_id, type)
{
	
	if(type==0){
		SWFFuns.cancelUpload(file_id);
	}else{
		HTML5Funs.cancelUpload(file_id);
	}
	
	$("#handle_button_"+file_id).html("已取消").removeClass("orange").addClass("gray");
	//如果已经上传一部分了
	if($("#progress_bar_p_"+file_id).hasClass("orange")){
			$("#progress_bar_p_"+file_id).removeClass("orange");
			$("#progress_bar_p_"+file_id).addClass("gray");
	}	
}


/**
 * 通过文件名称 从全局的文件列表中获取文件对象
 *
 */
function getFileFomeFilesUpload(filename){
	var len = filesUpload.length;
	for(var i=0; i < len; i++){
		if(filesUpload[i].name == filename){
			return filesUpload[i];
		}
	}
	
	return null;
}


/**
 * 往全局的 上传列表添加一个数据
 */
function addFileToFilesUpload(file){
	
	if(typeof file == "string"){
		filesUpload.push({"name":file})
		return true;
	}else if(typeof file == "object"){
		filesUpload.push(file);
		return true;
	}
	
	return false;
}

/**
 * 往全局的 上传列表添加一个数据
 */
function updateFileToFilesUpload(file){
	
	var len = filesUpload.length;
	for(var i=0; i < len; i++){
		if(filesUpload[i].name == file.name){
			filesUpload[i] = file;
			return true;
		}
	}
	
	return false;
}

/**
 * 查找在数组中的位置
 */
function findObjectKey (object, fid){
	var len = object.length; 
	for(var i=0; i<len; i++){
		if(object[i].id == fid){
			return i;
		}
	}
	return -1;
}

/**
 * 从全局的文件集合中移除文件，一般上传失败时使用
 * @param array files   文件对象集合  [{},{},{}]
 * @param int fid  要删除的文件id
 * @return 删除后的数组，  其实数组是引用类型可以不返回
 */
function removeFileFromFilesUpload(files, fid){
	
	var filesUploadKey = -1;
	
	filesUploadKey = findObjectKey(files, fid);
	//从全局文件中移除
	if(filesUploadKey > -1)
		 files.splice(filesUploadKey, 1);
		 
	return files;
}

function Base64() {
 
    // private property
    _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
 
    // public method for encoding
    this.encode = function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
            _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
            _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    }
 
    // public method for decoding
    this.decode = function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    }
 
    // private method for UTF-8 encoding
    _utf8_encode = function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
 
        }
        return utftext;
    }
 
    // private method for UTF-8 decoding
    _utf8_decode = function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while ( i < utftext.length ) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
}